package com.sample;

import java.io.InputStreamReader;
import java.io.Reader;

import org.drools.RuleBase;
import org.drools.RuleBaseFactory;
import org.drools.WorkingMemory;
import org.drools.compiler.PackageBuilder;
import org.drools.rule.Package;

public class DroolsTest {

    public static final void main(String[] args) {
        try {
        	
        	//Ucitavanje baze znanja
            RuleBase ruleBase = readRules();
            
            //Kreiranje radne memorije
            WorkingMemory workingMemory = ruleBase.newStatefulSession();
            
            //Kreiranje cinjenica
            Automobil a = new Automobil();
            
            a.setVerglanje("Ne");
            a.setRadeFarovi("Ne");
            a.setRadeLampice("Ne");
            
            //Unosenje cinjenica u radnu memoriju
            workingMemory.insert( a );
            
            //Pokretanje ES
            workingMemory.fireAllRules();   
            
            //Ispisivanje rezultata
            System.out.println(a);
            

        } catch (Throwable t) {
            t.printStackTrace();
        }
    }

 	private static RuleBase readRules() throws Exception {
		//Ucitavanje pravila iz fajla
		Reader source = new InputStreamReader( DroolsTest.class.getResourceAsStream( "/DijagnozaAutoKvarova.drl" ) );
		
		//Kreiranje paketa koji sadrzi sva pravila
		PackageBuilder builder = new PackageBuilder();
		
		builder.addPackageFromDrl( source );
		
		Package pkg = builder.getPackage();
		
		//Kreiranje baze znanja i dodavanje paketa u nju
		RuleBase ruleBase = RuleBaseFactory.newRuleBase();
		ruleBase.addPackage( pkg );
		return ruleBase;
	}
	
}
